<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content interface">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Interfaces</li>
  <li>INotificationCredentialsSchema</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/routes/user/user.controller.ts</code>
        </p>



        <section>
            <h3 id="index">Index</h3>
            <table class="table table-sm table-bordered index-table">
                <tbody>
                    <tr>
                        <td class="col-md-4">
                            <h6><b>Properties</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                        <a href="#_id">_id</a>
                                </li>
                                <li>
                                        <a href="#device_id">device_id</a>
                                </li>
                                <li>
                                        <a href="#notification_token">notification_token</a>
                                </li>
                                <li>
                                        <a href="#platform">platform</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
            </table>
        </section>



            <section>
                <h3 id="inputs">Properties</h3>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="_id"></a>
                                        <span class="name"><b>_id</b><a href="#_id"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>_id:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="device_id"></a>
                                        <span class="name"><b>device_id</b><a href="#device_id"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>device_id:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="notification_token"></a>
                                        <span class="name"><b>notification_token</b><a href="#notification_token"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>notification_token:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="platform"></a>
                                        <span class="name"><b>platform</b><a href="#platform"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>platform:         <code><a href="../miscellaneous/typealiases.html#DevicePlatforms" target="_self" >DevicePlatforms</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="../miscellaneous/typealiases.html#DevicePlatforms" target="_self" >DevicePlatforms</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
            </section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import * as Joi from &#x27;joi&#x27;
import { Controller, Logger, Get, Put, Body, UsePipes, Headers, Res, Inject } from &#x27;@nestjs/common&#x27;
import { Response } from &#x27;express&#x27;
import { ObjectId } from &#x27;mongodb&#x27;
import { DevicePlatformsEnum, DevicePlatforms } from &#x27;src/models/common/common&#x27;
import { JoiValidationPipe } from &#x27;src/pipes/joi-validation-pipe&#x27;
import { IUserEntityBase, IUserEntityBaseArrayMap, INotificationCredential } from &#x27;src/services/users/models&#x27;
import { UsersService } from &#x27;src/services/users/services/users.service&#x27;
import { ClientProxy } from &#x27;@nestjs/microservices&#x27;
import { MESSAGE_SERVICES } from &#x27;src&#x27;

// const updateUserSchema &#x3D; Joi.object&lt;IUserEntityBase&gt;({
//     // TODO: Implement non-array types here
// })

// const updateUserArraySchema &#x3D; Joi.object&lt;IUserEntityBaseArrayMap&gt;({
//     notification_credentials: Joi.object&lt;INotificationCredential&gt;({
//         device_id: Joi.string()
//             .min(5)
//             .max(100)
//             .required(),
//         notification_token: Joi.string()
//             .min(5)
//             .max(100)
//             .required(),
//         platform: Joi.string()
//             .valid(...Object.keys(DevicePlatformsEnum))
//             .required(),
//     }),
//     // TODO: Implement other array types
// })

interface INotificationCredentialsSchema {
    _id: string
    device_id: string
    notification_token: string
    platform: DevicePlatforms
}

const notificationCredentialsSchema &#x3D; Joi.object&lt;INotificationCredentialsSchema&gt;({
    // _id: Joi.string()
    //     .min(24)
    //     .max(24)
    //     .required(),
    // notification_credentials: Joi.object&lt;INotificationCredential&gt;({
    device_id: Joi.string()
        .min(5)
        .max(100)
        .required(),
    notification_token: Joi.string()
        .min(5)
        .max(300)
        .required(),
    platform: Joi.string()
        .valid(...Object.keys(DevicePlatformsEnum))
        .required(),
    // }),
    // TODO: Implement other array types
})

@Controller(&#x27;user&#x27;)
export class UserController {
    private readonly logger &#x3D; new Logger(UserController.name)

    constructor(
        private readonly usersService: UsersService,
        @Inject(MESSAGE_SERVICES.API_SERVICE) private client: ClientProxy,
    ) { }

    @Get(&#x27;test&#x27;)
    async test() {
        this.logger.debug(&#x27;test&#x27;)
        return this.client.send(
            {
                cmd: &#x27;sum&#x27;,
            },
            [1, 2, 3]
        )
    }

    @Get()
    async getCustomerId() {
    }

    async updateUser() { }

    async updateUserArray() { }

    @UsePipes(new JoiValidationPipe(notificationCredentialsSchema))
    @Put(&#x27;notification-credentials&#x27;)
    async updateUserNotificationCredentials(
        @Res() response: Response,
        @Headers(&#x27;_id&#x27;) _id: string,
        @Body() body: {
            device_id: string
            notification_token: string
            platform: DevicePlatforms
        },
    ) {
        this.logger.debug(this.updateUserNotificationCredentials.name)
        console.log(body)
        console.log(_id)

        const m_id &#x3D; new ObjectId(_id)

        const {
            device_id,
            notification_token,
            platform,
        } &#x3D; body

        // let pairs: &lt;
        //     T extends INotificationCredential,
        //     K extends keyof T
        //     &gt;({
        //         prop: K,
        //         value: T
        //     }) &#x3D;&gt; [] &#x3D; [
        //         {
        //             // array_prop: &#x27;notification_credentials&#x27;,
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id
        //         }
        //     ]

        // let array_filters &#x3D; [
        //     {
        //         prop: &#x27;device_id&#x27;,
        //         value: device_id,
        //     }
        // ]

        // let res &#x3D;
        //     await this.usersService
        //         .updateNotificationCredentials(m_id, {
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id
        //         }, array_filters)

        // let res &#x3D;
        //     await this.usersService
        //         .updateNotificationCredentials(m_id, [{
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id
        //         }, {
        //             prop: &#x27;&#x27;
        //         }], [{
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id,
        //         }])

        let res &#x3D;
            await this.usersService
                .updateNotificationCredentials(m_id, {
                    device_id,
                    notification_token,
                    platform,
                    created: new Date(),
                    updated: new Date(),
                }, {
                    device_id,
                    // notification_token,
                    platform
                })

        response.status(200).send()

        // let res &#x3D;
        //     await this.usersService
        //         .updateUserElementInArray(m_id, pairs, array_filters)

        // let res &#x3D; 
        //     await this.usersService
        //     .updateUserElementInArray(m_id, [
        //         {
        //             array_prop: &#x27;notification_credentials&#x27;,
        //             prop: &#x27;platform&#x27;,
        //             value: &#x27;android&#x27;,
        //         },
        //         {
        //             array_prop: &#x27;notification_credentials&#x27;,
        //             prop: &#x27;device_id&#x27;,
        //             value: &#x27;&#x27;,
        //         },
        //     ], [
        //         {
        //             prop: &#x27;device_id&#x27;,
        //             value: &#x27;&#x27;,
        //         }
        //     ])
        //     // ], [
        //     //     {
        //     //         prop: &#x27;notification_credentials&#x27;,
        //     //         value: {

        //     //         }
        //     //     }
        //     // ])
    }
}
</code></pre>
    </div>
</div>


                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'interface';
            var COMPODOC_CURRENT_PAGE_URL = 'INotificationCredentialsSchema.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
